"""A web3.py Contract class for the IDeterministicDeployer contract.

DO NOT EDIT.  This file was generated by pypechain v0.0.49.
See documentation at https://github.com/delvtech/pypechain """

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# This file is bound to get very long depending on contract sizes.
# pylint: disable=too-many-lines

# methods are overridden with specific arguments instead of generic *args, **kwargs
# pylint: disable=arguments-differ

# consumers have too many opinions on line length
# pylint: disable=line-too-long

# We use protected classes within pypechain
# pylint: disable=protected-access

# We sometimes define a variable that might not be returned in `call`,
# but we still may want to call the function
# pylint: disable=unused-variable


from __future__ import annotations

from typing import Any, Iterable, Sequence, Type, cast, overload

from eth_account.signers.local import LocalAccount
from eth_typing import ABI, ChecksumAddress, HexStr
from hexbytes import HexBytes
from pypechain.core import (
    PypechainBaseContractErrors,
    PypechainBaseError,
    PypechainContractFunction,
    PypechainOverloadedFunctions,
    combomethod_typed,
    dataclass_to_tuple,
    expand_struct_type_str,
    get_arg_type_names,
    rename_returned_types,
)
from typing_extensions import Self
from web3 import Web3
from web3._utils.events import EventLogErrorFlags
from web3._utils.filters import LogFilter
from web3.contract.contract import (
    Contract,
    ContractConstructor,
    ContractEvent,
    ContractEvents,
    ContractFunctions,
)
from web3.logs import WARN
from web3.types import BlockIdentifier, StateOverride, TxParams, TxReceipt

from ..ICreateX import ICreateXTypes as ICreateX
from .IDeterministicDeployerTypes import (
    ContractCreationEvent,
    Create3ProxyContractCreationEvent,
)

structs = {
    "ICreateX.Values": ICreateX.Values,
}

ideterministicdeployer_abi: ABI = cast(
    ABI,
    [
        {
            "type": "function",
            "name": "computeCreate2Address",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {
                    "name": "initCodeHash",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [
                {
                    "name": "computedAddress",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "computeCreate2Address",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {
                    "name": "initCodeHash",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
                {
                    "name": "deployer",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [
                {
                    "name": "computedAddress",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "computeCreate3Address",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {
                    "name": "deployer",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [
                {
                    "name": "computedAddress",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "computeCreate3Address",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"}
            ],
            "outputs": [
                {
                    "name": "computedAddress",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "computeCreateAddress",
            "inputs": [
                {"name": "nonce", "type": "uint256", "internalType": "uint256"}
            ],
            "outputs": [
                {
                    "name": "computedAddress",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "computeCreateAddress",
            "inputs": [
                {
                    "name": "deployer",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "nonce", "type": "uint256", "internalType": "uint256"},
            ],
            "outputs": [
                {
                    "name": "computedAddress",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "deployCreate",
            "inputs": [
                {"name": "initCode", "type": "bytes", "internalType": "bytes"}
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate2",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate2",
            "inputs": [
                {"name": "initCode", "type": "bytes", "internalType": "bytes"}
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate2AndInit",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "values",
                    "type": "tuple",
                    "internalType": "struct ICreateX.Values",
                    "components": [
                        {
                            "name": "constructorAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "initCallAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                },
                {
                    "name": "refundAddress",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate2AndInit",
            "inputs": [
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "values",
                    "type": "tuple",
                    "internalType": "struct ICreateX.Values",
                    "components": [
                        {
                            "name": "constructorAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "initCallAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                },
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate2AndInit",
            "inputs": [
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "values",
                    "type": "tuple",
                    "internalType": "struct ICreateX.Values",
                    "components": [
                        {
                            "name": "constructorAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "initCallAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                },
                {
                    "name": "refundAddress",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate2AndInit",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "values",
                    "type": "tuple",
                    "internalType": "struct ICreateX.Values",
                    "components": [
                        {
                            "name": "constructorAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "initCallAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                },
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate2Clone",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {
                    "name": "implementation",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "data", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [
                {"name": "proxy", "type": "address", "internalType": "address"}
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate2Clone",
            "inputs": [
                {
                    "name": "implementation",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "data", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [
                {"name": "proxy", "type": "address", "internalType": "address"}
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate3",
            "inputs": [
                {"name": "initCode", "type": "bytes", "internalType": "bytes"}
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate3",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate3AndInit",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "values",
                    "type": "tuple",
                    "internalType": "struct ICreateX.Values",
                    "components": [
                        {
                            "name": "constructorAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "initCallAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                },
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate3AndInit",
            "inputs": [
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "values",
                    "type": "tuple",
                    "internalType": "struct ICreateX.Values",
                    "components": [
                        {
                            "name": "constructorAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "initCallAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                },
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate3AndInit",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "values",
                    "type": "tuple",
                    "internalType": "struct ICreateX.Values",
                    "components": [
                        {
                            "name": "constructorAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "initCallAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                },
                {
                    "name": "refundAddress",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreate3AndInit",
            "inputs": [
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "values",
                    "type": "tuple",
                    "internalType": "struct ICreateX.Values",
                    "components": [
                        {
                            "name": "constructorAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "initCallAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                },
                {
                    "name": "refundAddress",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreateAndInit",
            "inputs": [
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "values",
                    "type": "tuple",
                    "internalType": "struct ICreateX.Values",
                    "components": [
                        {
                            "name": "constructorAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "initCallAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                },
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreateAndInit",
            "inputs": [
                {"name": "initCode", "type": "bytes", "internalType": "bytes"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "values",
                    "type": "tuple",
                    "internalType": "struct ICreateX.Values",
                    "components": [
                        {
                            "name": "constructorAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "initCallAmount",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                },
                {
                    "name": "refundAddress",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "deployCreateClone",
            "inputs": [
                {
                    "name": "implementation",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "data", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [
                {"name": "proxy", "type": "address", "internalType": "address"}
            ],
            "stateMutability": "payable",
        },
        {
            "type": "event",
            "name": "ContractCreation",
            "inputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "indexed": True,
                    "internalType": "address",
                },
                {
                    "name": "salt",
                    "type": "bytes32",
                    "indexed": True,
                    "internalType": "bytes32",
                },
            ],
            "anonymous": False,
        },
        {
            "type": "event",
            "name": "ContractCreation",
            "inputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "indexed": True,
                    "internalType": "address",
                }
            ],
            "anonymous": False,
        },
        {
            "type": "event",
            "name": "Create3ProxyContractCreation",
            "inputs": [
                {
                    "name": "newContract",
                    "type": "address",
                    "indexed": True,
                    "internalType": "address",
                },
                {
                    "name": "salt",
                    "type": "bytes32",
                    "indexed": True,
                    "internalType": "bytes32",
                },
            ],
            "anonymous": False,
        },
        {
            "type": "error",
            "name": "FailedContractCreation",
            "inputs": [
                {
                    "name": "emitter",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "FailedContractInitialisation",
            "inputs": [
                {
                    "name": "emitter",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "revertData",
                    "type": "bytes",
                    "internalType": "bytes",
                },
            ],
        },
        {
            "type": "error",
            "name": "FailedEtherTransfer",
            "inputs": [
                {
                    "name": "emitter",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "revertData",
                    "type": "bytes",
                    "internalType": "bytes",
                },
            ],
        },
        {
            "type": "error",
            "name": "InvalidNonceValue",
            "inputs": [
                {
                    "name": "emitter",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "InvalidSalt",
            "inputs": [
                {
                    "name": "emitter",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
    ],
)


class IDeterministicDeployerFailedContractCreationContractError(
    PypechainBaseError
):
    """ContractError for FailedContractCreation."""

    # Error name
    name: str = "FailedContractCreation"
    # 4 byte error selector
    selector: str = "0xc05cee7a"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "FailedContractCreation(address)"
    # Error input types
    abi: ABI = ideterministicdeployer_abi


class IDeterministicDeployerFailedContractInitialisationContractError(
    PypechainBaseError
):
    """ContractError for FailedContractInitialisation."""

    # Error name
    name: str = "FailedContractInitialisation"
    # 4 byte error selector
    selector: str = "0xa57ca239"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "FailedContractInitialisation(address,bytes)"
    # Error input types
    abi: ABI = ideterministicdeployer_abi


class IDeterministicDeployerFailedEtherTransferContractError(
    PypechainBaseError
):
    """ContractError for FailedEtherTransfer."""

    # Error name
    name: str = "FailedEtherTransfer"
    # 4 byte error selector
    selector: str = "0xc2b3f445"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "FailedEtherTransfer(address,bytes)"
    # Error input types
    abi: ABI = ideterministicdeployer_abi


class IDeterministicDeployerInvalidNonceValueContractError(PypechainBaseError):
    """ContractError for InvalidNonceValue."""

    # Error name
    name: str = "InvalidNonceValue"
    # 4 byte error selector
    selector: str = "0x3c55ab3b"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "InvalidNonceValue(address)"
    # Error input types
    abi: ABI = ideterministicdeployer_abi


class IDeterministicDeployerInvalidSaltContractError(PypechainBaseError):
    """ContractError for InvalidSalt."""

    # Error name
    name: str = "InvalidSalt"
    # 4 byte error selector
    selector: str = "0x13b3a2a1"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "InvalidSalt(address)"
    # Error input types
    abi: ABI = ideterministicdeployer_abi


class IDeterministicDeployerContractErrors(PypechainBaseContractErrors):
    """ContractErrors for the IDeterministicDeployer contract."""

    FailedContractCreation: (
        IDeterministicDeployerFailedContractCreationContractError
    )

    FailedContractInitialisation: (
        IDeterministicDeployerFailedContractInitialisationContractError
    )

    FailedEtherTransfer: IDeterministicDeployerFailedEtherTransferContractError

    InvalidNonceValue: IDeterministicDeployerInvalidNonceValueContractError

    InvalidSalt: IDeterministicDeployerInvalidSaltContractError

    def __init__(
        self,
    ) -> None:
        self.FailedContractCreation = (
            IDeterministicDeployerFailedContractCreationContractError()
        )
        self.FailedContractInitialisation = (
            IDeterministicDeployerFailedContractInitialisationContractError()
        )
        self.FailedEtherTransfer = (
            IDeterministicDeployerFailedEtherTransferContractError()
        )
        self.InvalidNonceValue = (
            IDeterministicDeployerInvalidNonceValueContractError()
        )
        self.InvalidSalt = IDeterministicDeployerInvalidSaltContractError()

        self._all = [
            self.FailedContractCreation,
            self.FailedContractInitialisation,
            self.FailedEtherTransfer,
            self.InvalidNonceValue,
            self.InvalidSalt,
        ]


class IDeterministicDeployerComputeCreate2AddressContractFunction0(
    PypechainContractFunction
):
    """ContractFunction for the computeCreate2Address(bytes,bytes) method."""

    _function_name = "computeCreate2Address"
    _type_signature = expand_struct_type_str(tuple(["bytes", "bytes"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerComputeCreate2AddressContractFunction1(
    PypechainContractFunction
):
    """ContractFunction for the computeCreate2Address(bytes,bytes,str) method."""

    _function_name = "computeCreate2Address"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "bytes", "str"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerComputeCreate2AddressContractFunction(
    PypechainOverloadedFunctions
):
    """ContractFunction for the computeCreate2Address method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    _function_name = "computeCreate2Address"

    # Make lookup for function signature -> overloaded function
    # The function signatures are python types, as we need to do a
    # lookup of arguments passed in to contract function
    _functions: dict[str, PypechainContractFunction]

    @overload
    def __call__(self, salt: bytes, initCodeHash: bytes) -> IDeterministicDeployerComputeCreate2AddressContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, salt: bytes, initCodeHash: bytes, deployer: str) -> IDeterministicDeployerComputeCreate2AddressContractFunction1:  # type: ignore
        ...

    def __call__(self, *args, **kwargs) -> IDeterministicDeployerComputeCreate2AddressContractFunction:  # type: ignore
        # Special case when there are no args or kwargs
        if len(args) == 0 and len(kwargs) == 0:
            # We need to specify the element identifier as the function call without arguments.
            # Despite this setting the member variable `abi_element_identifier`
            # that's shared across this object, this field gets overwritten in the
            # clone if arguments are provided.
            self.abi_element_identifier = self._function_name + "()"
            clone = super().__call__()
        else:
            clone = super().__call__(
                *(dataclass_to_tuple(arg) for arg in args),
                **{key: dataclass_to_tuple(arg) for key, arg in kwargs.items()},
            )

        # Arguments is the flattened set of arguments from args and kwargs, ordered by the abi
        # We get the python types of the args passed in, but remapped from tuples -> dataclasses
        arg_types = get_arg_type_names(clone.arguments)

        # Grab the relevant kwargs when factory was called.
        factory_kwargs = self._factory_kwargs
        factory_kwargs["abi_element_identifier"] = clone.abi_element_identifier

        function_obj = self._overloaded_functions[arg_types].factory(
            self._function_name, **factory_kwargs
        )

        function_obj.args = clone.args
        function_obj.kwargs = clone.kwargs

        # The `@overload` of `__call__` takes care of setting the type of this object correctly
        return function_obj  # type: ignore

    @classmethod
    def factory(cls, class_name: str, **kwargs: Any) -> Self:
        out = super().factory(class_name, **kwargs)
        # Store the factory args for downstream consumption
        out._factory_kwargs = kwargs

        # We initialize our overridden functions here.
        # Note that we use the initialized object to ensure each function
        # is attached to the instantiated object
        # (attached to a specific web3 and contract address)
        out._overloaded_functions = {
            IDeterministicDeployerComputeCreate2AddressContractFunction0._type_signature: IDeterministicDeployerComputeCreate2AddressContractFunction0,
            IDeterministicDeployerComputeCreate2AddressContractFunction1._type_signature: IDeterministicDeployerComputeCreate2AddressContractFunction1,
        }
        return out


class IDeterministicDeployerComputeCreate3AddressContractFunction0(
    PypechainContractFunction
):
    """ContractFunction for the computeCreate3Address(bytes,str) method."""

    _function_name = "computeCreate3Address"
    _type_signature = expand_struct_type_str(tuple(["bytes", "str"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerComputeCreate3AddressContractFunction1(
    PypechainContractFunction
):
    """ContractFunction for the computeCreate3Address(bytes) method."""

    _function_name = "computeCreate3Address"
    _type_signature = expand_struct_type_str(tuple(["bytes"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerComputeCreate3AddressContractFunction(
    PypechainOverloadedFunctions
):
    """ContractFunction for the computeCreate3Address method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    _function_name = "computeCreate3Address"

    # Make lookup for function signature -> overloaded function
    # The function signatures are python types, as we need to do a
    # lookup of arguments passed in to contract function
    _functions: dict[str, PypechainContractFunction]

    @overload
    def __call__(self, salt: bytes, deployer: str) -> IDeterministicDeployerComputeCreate3AddressContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, salt: bytes) -> IDeterministicDeployerComputeCreate3AddressContractFunction1:  # type: ignore
        ...

    def __call__(self, *args, **kwargs) -> IDeterministicDeployerComputeCreate3AddressContractFunction:  # type: ignore
        # Special case when there are no args or kwargs
        if len(args) == 0 and len(kwargs) == 0:
            # We need to specify the element identifier as the function call without arguments.
            # Despite this setting the member variable `abi_element_identifier`
            # that's shared across this object, this field gets overwritten in the
            # clone if arguments are provided.
            self.abi_element_identifier = self._function_name + "()"
            clone = super().__call__()
        else:
            clone = super().__call__(
                *(dataclass_to_tuple(arg) for arg in args),
                **{key: dataclass_to_tuple(arg) for key, arg in kwargs.items()},
            )

        # Arguments is the flattened set of arguments from args and kwargs, ordered by the abi
        # We get the python types of the args passed in, but remapped from tuples -> dataclasses
        arg_types = get_arg_type_names(clone.arguments)

        # Grab the relevant kwargs when factory was called.
        factory_kwargs = self._factory_kwargs
        factory_kwargs["abi_element_identifier"] = clone.abi_element_identifier

        function_obj = self._overloaded_functions[arg_types].factory(
            self._function_name, **factory_kwargs
        )

        function_obj.args = clone.args
        function_obj.kwargs = clone.kwargs

        # The `@overload` of `__call__` takes care of setting the type of this object correctly
        return function_obj  # type: ignore

    @classmethod
    def factory(cls, class_name: str, **kwargs: Any) -> Self:
        out = super().factory(class_name, **kwargs)
        # Store the factory args for downstream consumption
        out._factory_kwargs = kwargs

        # We initialize our overridden functions here.
        # Note that we use the initialized object to ensure each function
        # is attached to the instantiated object
        # (attached to a specific web3 and contract address)
        out._overloaded_functions = {
            IDeterministicDeployerComputeCreate3AddressContractFunction0._type_signature: IDeterministicDeployerComputeCreate3AddressContractFunction0,
            IDeterministicDeployerComputeCreate3AddressContractFunction1._type_signature: IDeterministicDeployerComputeCreate3AddressContractFunction1,
        }
        return out


class IDeterministicDeployerComputeCreateAddressContractFunction0(
    PypechainContractFunction
):
    """ContractFunction for the computeCreateAddress(int) method."""

    _function_name = "computeCreateAddress"
    _type_signature = expand_struct_type_str(tuple(["int"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerComputeCreateAddressContractFunction1(
    PypechainContractFunction
):
    """ContractFunction for the computeCreateAddress(str,int) method."""

    _function_name = "computeCreateAddress"
    _type_signature = expand_struct_type_str(tuple(["str", "int"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerComputeCreateAddressContractFunction(
    PypechainOverloadedFunctions
):
    """ContractFunction for the computeCreateAddress method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    _function_name = "computeCreateAddress"

    # Make lookup for function signature -> overloaded function
    # The function signatures are python types, as we need to do a
    # lookup of arguments passed in to contract function
    _functions: dict[str, PypechainContractFunction]

    @overload
    def __call__(self, nonce: int) -> IDeterministicDeployerComputeCreateAddressContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, deployer: str, nonce: int) -> IDeterministicDeployerComputeCreateAddressContractFunction1:  # type: ignore
        ...

    def __call__(self, *args, **kwargs) -> IDeterministicDeployerComputeCreateAddressContractFunction:  # type: ignore
        # Special case when there are no args or kwargs
        if len(args) == 0 and len(kwargs) == 0:
            # We need to specify the element identifier as the function call without arguments.
            # Despite this setting the member variable `abi_element_identifier`
            # that's shared across this object, this field gets overwritten in the
            # clone if arguments are provided.
            self.abi_element_identifier = self._function_name + "()"
            clone = super().__call__()
        else:
            clone = super().__call__(
                *(dataclass_to_tuple(arg) for arg in args),
                **{key: dataclass_to_tuple(arg) for key, arg in kwargs.items()},
            )

        # Arguments is the flattened set of arguments from args and kwargs, ordered by the abi
        # We get the python types of the args passed in, but remapped from tuples -> dataclasses
        arg_types = get_arg_type_names(clone.arguments)

        # Grab the relevant kwargs when factory was called.
        factory_kwargs = self._factory_kwargs
        factory_kwargs["abi_element_identifier"] = clone.abi_element_identifier

        function_obj = self._overloaded_functions[arg_types].factory(
            self._function_name, **factory_kwargs
        )

        function_obj.args = clone.args
        function_obj.kwargs = clone.kwargs

        # The `@overload` of `__call__` takes care of setting the type of this object correctly
        return function_obj  # type: ignore

    @classmethod
    def factory(cls, class_name: str, **kwargs: Any) -> Self:
        out = super().factory(class_name, **kwargs)
        # Store the factory args for downstream consumption
        out._factory_kwargs = kwargs

        # We initialize our overridden functions here.
        # Note that we use the initialized object to ensure each function
        # is attached to the instantiated object
        # (attached to a specific web3 and contract address)
        out._overloaded_functions = {
            IDeterministicDeployerComputeCreateAddressContractFunction0._type_signature: IDeterministicDeployerComputeCreateAddressContractFunction0,
            IDeterministicDeployerComputeCreateAddressContractFunction1._type_signature: IDeterministicDeployerComputeCreateAddressContractFunction1,
        }
        return out


class IDeterministicDeployerDeployCreateContractFunction0(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate(bytes) method."""

    _function_name = "deployCreate"
    _type_signature = expand_struct_type_str(tuple(["bytes"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreateContractFunction(
    PypechainOverloadedFunctions
):
    """ContractFunction for the deployCreate method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    _function_name = "deployCreate"

    # Make lookup for function signature -> overloaded function
    # The function signatures are python types, as we need to do a
    # lookup of arguments passed in to contract function
    _functions: dict[str, PypechainContractFunction]

    @overload
    def __call__(self, initCode: bytes) -> IDeterministicDeployerDeployCreateContractFunction0:  # type: ignore
        ...

    def __call__(self, *args, **kwargs) -> IDeterministicDeployerDeployCreateContractFunction:  # type: ignore
        # Special case when there are no args or kwargs
        if len(args) == 0 and len(kwargs) == 0:
            # We need to specify the element identifier as the function call without arguments.
            # Despite this setting the member variable `abi_element_identifier`
            # that's shared across this object, this field gets overwritten in the
            # clone if arguments are provided.
            self.abi_element_identifier = self._function_name + "()"
            clone = super().__call__()
        else:
            clone = super().__call__(
                *(dataclass_to_tuple(arg) for arg in args),
                **{key: dataclass_to_tuple(arg) for key, arg in kwargs.items()},
            )

        # Arguments is the flattened set of arguments from args and kwargs, ordered by the abi
        # We get the python types of the args passed in, but remapped from tuples -> dataclasses
        arg_types = get_arg_type_names(clone.arguments)

        # Grab the relevant kwargs when factory was called.
        factory_kwargs = self._factory_kwargs
        factory_kwargs["abi_element_identifier"] = clone.abi_element_identifier

        function_obj = self._overloaded_functions[arg_types].factory(
            self._function_name, **factory_kwargs
        )

        function_obj.args = clone.args
        function_obj.kwargs = clone.kwargs

        # The `@overload` of `__call__` takes care of setting the type of this object correctly
        return function_obj  # type: ignore

    @classmethod
    def factory(cls, class_name: str, **kwargs: Any) -> Self:
        out = super().factory(class_name, **kwargs)
        # Store the factory args for downstream consumption
        out._factory_kwargs = kwargs

        # We initialize our overridden functions here.
        # Note that we use the initialized object to ensure each function
        # is attached to the instantiated object
        # (attached to a specific web3 and contract address)
        out._overloaded_functions = {
            IDeterministicDeployerDeployCreateContractFunction0._type_signature: IDeterministicDeployerDeployCreateContractFunction0,
        }
        return out


class IDeterministicDeployerDeployCreate2ContractFunction0(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate2(bytes,bytes) method."""

    _function_name = "deployCreate2"
    _type_signature = expand_struct_type_str(tuple(["bytes", "bytes"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate2ContractFunction1(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate2(bytes) method."""

    _function_name = "deployCreate2"
    _type_signature = expand_struct_type_str(tuple(["bytes"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate2ContractFunction(
    PypechainOverloadedFunctions
):
    """ContractFunction for the deployCreate2 method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    _function_name = "deployCreate2"

    # Make lookup for function signature -> overloaded function
    # The function signatures are python types, as we need to do a
    # lookup of arguments passed in to contract function
    _functions: dict[str, PypechainContractFunction]

    @overload
    def __call__(self, salt: bytes, initCode: bytes) -> IDeterministicDeployerDeployCreate2ContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, initCode: bytes) -> IDeterministicDeployerDeployCreate2ContractFunction1:  # type: ignore
        ...

    def __call__(self, *args, **kwargs) -> IDeterministicDeployerDeployCreate2ContractFunction:  # type: ignore
        # Special case when there are no args or kwargs
        if len(args) == 0 and len(kwargs) == 0:
            # We need to specify the element identifier as the function call without arguments.
            # Despite this setting the member variable `abi_element_identifier`
            # that's shared across this object, this field gets overwritten in the
            # clone if arguments are provided.
            self.abi_element_identifier = self._function_name + "()"
            clone = super().__call__()
        else:
            clone = super().__call__(
                *(dataclass_to_tuple(arg) for arg in args),
                **{key: dataclass_to_tuple(arg) for key, arg in kwargs.items()},
            )

        # Arguments is the flattened set of arguments from args and kwargs, ordered by the abi
        # We get the python types of the args passed in, but remapped from tuples -> dataclasses
        arg_types = get_arg_type_names(clone.arguments)

        # Grab the relevant kwargs when factory was called.
        factory_kwargs = self._factory_kwargs
        factory_kwargs["abi_element_identifier"] = clone.abi_element_identifier

        function_obj = self._overloaded_functions[arg_types].factory(
            self._function_name, **factory_kwargs
        )

        function_obj.args = clone.args
        function_obj.kwargs = clone.kwargs

        # The `@overload` of `__call__` takes care of setting the type of this object correctly
        return function_obj  # type: ignore

    @classmethod
    def factory(cls, class_name: str, **kwargs: Any) -> Self:
        out = super().factory(class_name, **kwargs)
        # Store the factory args for downstream consumption
        out._factory_kwargs = kwargs

        # We initialize our overridden functions here.
        # Note that we use the initialized object to ensure each function
        # is attached to the instantiated object
        # (attached to a specific web3 and contract address)
        out._overloaded_functions = {
            IDeterministicDeployerDeployCreate2ContractFunction0._type_signature: IDeterministicDeployerDeployCreate2ContractFunction0,
            IDeterministicDeployerDeployCreate2ContractFunction1._type_signature: IDeterministicDeployerDeployCreate2ContractFunction1,
        }
        return out


class IDeterministicDeployerDeployCreate2AndInitContractFunction0(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate2AndInit(bytes,bytes,bytes,ICreateX.Values,str) method."""

    _function_name = "deployCreate2AndInit"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "bytes", "bytes", "ICreateX.Values", "str"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate2AndInitContractFunction1(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate2AndInit(bytes,bytes,ICreateX.Values) method."""

    _function_name = "deployCreate2AndInit"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "bytes", "ICreateX.Values"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate2AndInitContractFunction2(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate2AndInit(bytes,bytes,ICreateX.Values,str) method."""

    _function_name = "deployCreate2AndInit"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "bytes", "ICreateX.Values", "str"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate2AndInitContractFunction3(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate2AndInit(bytes,bytes,bytes,ICreateX.Values) method."""

    _function_name = "deployCreate2AndInit"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "bytes", "bytes", "ICreateX.Values"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate2AndInitContractFunction(
    PypechainOverloadedFunctions
):
    """ContractFunction for the deployCreate2AndInit method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    _function_name = "deployCreate2AndInit"

    # Make lookup for function signature -> overloaded function
    # The function signatures are python types, as we need to do a
    # lookup of arguments passed in to contract function
    _functions: dict[str, PypechainContractFunction]

    @overload
    def __call__(self, salt: bytes, initCode: bytes, data: bytes, values: ICreateX.Values, refundAddress: str) -> IDeterministicDeployerDeployCreate2AndInitContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, initCode: bytes, data: bytes, values: ICreateX.Values) -> IDeterministicDeployerDeployCreate2AndInitContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, initCode: bytes, data: bytes, values: ICreateX.Values, refundAddress: str) -> IDeterministicDeployerDeployCreate2AndInitContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, salt: bytes, initCode: bytes, data: bytes, values: ICreateX.Values) -> IDeterministicDeployerDeployCreate2AndInitContractFunction3:  # type: ignore
        ...

    def __call__(self, *args, **kwargs) -> IDeterministicDeployerDeployCreate2AndInitContractFunction:  # type: ignore
        # Special case when there are no args or kwargs
        if len(args) == 0 and len(kwargs) == 0:
            # We need to specify the element identifier as the function call without arguments.
            # Despite this setting the member variable `abi_element_identifier`
            # that's shared across this object, this field gets overwritten in the
            # clone if arguments are provided.
            self.abi_element_identifier = self._function_name + "()"
            clone = super().__call__()
        else:
            clone = super().__call__(
                *(dataclass_to_tuple(arg) for arg in args),
                **{key: dataclass_to_tuple(arg) for key, arg in kwargs.items()},
            )

        # Arguments is the flattened set of arguments from args and kwargs, ordered by the abi
        # We get the python types of the args passed in, but remapped from tuples -> dataclasses
        arg_types = get_arg_type_names(clone.arguments)

        # Grab the relevant kwargs when factory was called.
        factory_kwargs = self._factory_kwargs
        factory_kwargs["abi_element_identifier"] = clone.abi_element_identifier

        function_obj = self._overloaded_functions[arg_types].factory(
            self._function_name, **factory_kwargs
        )

        function_obj.args = clone.args
        function_obj.kwargs = clone.kwargs

        # The `@overload` of `__call__` takes care of setting the type of this object correctly
        return function_obj  # type: ignore

    @classmethod
    def factory(cls, class_name: str, **kwargs: Any) -> Self:
        out = super().factory(class_name, **kwargs)
        # Store the factory args for downstream consumption
        out._factory_kwargs = kwargs

        # We initialize our overridden functions here.
        # Note that we use the initialized object to ensure each function
        # is attached to the instantiated object
        # (attached to a specific web3 and contract address)
        out._overloaded_functions = {
            IDeterministicDeployerDeployCreate2AndInitContractFunction0._type_signature: IDeterministicDeployerDeployCreate2AndInitContractFunction0,
            IDeterministicDeployerDeployCreate2AndInitContractFunction1._type_signature: IDeterministicDeployerDeployCreate2AndInitContractFunction1,
            IDeterministicDeployerDeployCreate2AndInitContractFunction2._type_signature: IDeterministicDeployerDeployCreate2AndInitContractFunction2,
            IDeterministicDeployerDeployCreate2AndInitContractFunction3._type_signature: IDeterministicDeployerDeployCreate2AndInitContractFunction3,
        }
        return out


class IDeterministicDeployerDeployCreate2CloneContractFunction0(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate2Clone(bytes,str,bytes) method."""

    _function_name = "deployCreate2Clone"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "str", "bytes"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate2CloneContractFunction1(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate2Clone(str,bytes) method."""

    _function_name = "deployCreate2Clone"
    _type_signature = expand_struct_type_str(tuple(["str", "bytes"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate2CloneContractFunction(
    PypechainOverloadedFunctions
):
    """ContractFunction for the deployCreate2Clone method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    _function_name = "deployCreate2Clone"

    # Make lookup for function signature -> overloaded function
    # The function signatures are python types, as we need to do a
    # lookup of arguments passed in to contract function
    _functions: dict[str, PypechainContractFunction]

    @overload
    def __call__(self, salt: bytes, implementation: str, data: bytes) -> IDeterministicDeployerDeployCreate2CloneContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, implementation: str, data: bytes) -> IDeterministicDeployerDeployCreate2CloneContractFunction1:  # type: ignore
        ...

    def __call__(self, *args, **kwargs) -> IDeterministicDeployerDeployCreate2CloneContractFunction:  # type: ignore
        # Special case when there are no args or kwargs
        if len(args) == 0 and len(kwargs) == 0:
            # We need to specify the element identifier as the function call without arguments.
            # Despite this setting the member variable `abi_element_identifier`
            # that's shared across this object, this field gets overwritten in the
            # clone if arguments are provided.
            self.abi_element_identifier = self._function_name + "()"
            clone = super().__call__()
        else:
            clone = super().__call__(
                *(dataclass_to_tuple(arg) for arg in args),
                **{key: dataclass_to_tuple(arg) for key, arg in kwargs.items()},
            )

        # Arguments is the flattened set of arguments from args and kwargs, ordered by the abi
        # We get the python types of the args passed in, but remapped from tuples -> dataclasses
        arg_types = get_arg_type_names(clone.arguments)

        # Grab the relevant kwargs when factory was called.
        factory_kwargs = self._factory_kwargs
        factory_kwargs["abi_element_identifier"] = clone.abi_element_identifier

        function_obj = self._overloaded_functions[arg_types].factory(
            self._function_name, **factory_kwargs
        )

        function_obj.args = clone.args
        function_obj.kwargs = clone.kwargs

        # The `@overload` of `__call__` takes care of setting the type of this object correctly
        return function_obj  # type: ignore

    @classmethod
    def factory(cls, class_name: str, **kwargs: Any) -> Self:
        out = super().factory(class_name, **kwargs)
        # Store the factory args for downstream consumption
        out._factory_kwargs = kwargs

        # We initialize our overridden functions here.
        # Note that we use the initialized object to ensure each function
        # is attached to the instantiated object
        # (attached to a specific web3 and contract address)
        out._overloaded_functions = {
            IDeterministicDeployerDeployCreate2CloneContractFunction0._type_signature: IDeterministicDeployerDeployCreate2CloneContractFunction0,
            IDeterministicDeployerDeployCreate2CloneContractFunction1._type_signature: IDeterministicDeployerDeployCreate2CloneContractFunction1,
        }
        return out


class IDeterministicDeployerDeployCreate3ContractFunction0(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate3(bytes) method."""

    _function_name = "deployCreate3"
    _type_signature = expand_struct_type_str(tuple(["bytes"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate3ContractFunction1(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate3(bytes,bytes) method."""

    _function_name = "deployCreate3"
    _type_signature = expand_struct_type_str(tuple(["bytes", "bytes"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate3ContractFunction(
    PypechainOverloadedFunctions
):
    """ContractFunction for the deployCreate3 method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    _function_name = "deployCreate3"

    # Make lookup for function signature -> overloaded function
    # The function signatures are python types, as we need to do a
    # lookup of arguments passed in to contract function
    _functions: dict[str, PypechainContractFunction]

    @overload
    def __call__(self, initCode: bytes) -> IDeterministicDeployerDeployCreate3ContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, salt: bytes, initCode: bytes) -> IDeterministicDeployerDeployCreate3ContractFunction1:  # type: ignore
        ...

    def __call__(self, *args, **kwargs) -> IDeterministicDeployerDeployCreate3ContractFunction:  # type: ignore
        # Special case when there are no args or kwargs
        if len(args) == 0 and len(kwargs) == 0:
            # We need to specify the element identifier as the function call without arguments.
            # Despite this setting the member variable `abi_element_identifier`
            # that's shared across this object, this field gets overwritten in the
            # clone if arguments are provided.
            self.abi_element_identifier = self._function_name + "()"
            clone = super().__call__()
        else:
            clone = super().__call__(
                *(dataclass_to_tuple(arg) for arg in args),
                **{key: dataclass_to_tuple(arg) for key, arg in kwargs.items()},
            )

        # Arguments is the flattened set of arguments from args and kwargs, ordered by the abi
        # We get the python types of the args passed in, but remapped from tuples -> dataclasses
        arg_types = get_arg_type_names(clone.arguments)

        # Grab the relevant kwargs when factory was called.
        factory_kwargs = self._factory_kwargs
        factory_kwargs["abi_element_identifier"] = clone.abi_element_identifier

        function_obj = self._overloaded_functions[arg_types].factory(
            self._function_name, **factory_kwargs
        )

        function_obj.args = clone.args
        function_obj.kwargs = clone.kwargs

        # The `@overload` of `__call__` takes care of setting the type of this object correctly
        return function_obj  # type: ignore

    @classmethod
    def factory(cls, class_name: str, **kwargs: Any) -> Self:
        out = super().factory(class_name, **kwargs)
        # Store the factory args for downstream consumption
        out._factory_kwargs = kwargs

        # We initialize our overridden functions here.
        # Note that we use the initialized object to ensure each function
        # is attached to the instantiated object
        # (attached to a specific web3 and contract address)
        out._overloaded_functions = {
            IDeterministicDeployerDeployCreate3ContractFunction0._type_signature: IDeterministicDeployerDeployCreate3ContractFunction0,
            IDeterministicDeployerDeployCreate3ContractFunction1._type_signature: IDeterministicDeployerDeployCreate3ContractFunction1,
        }
        return out


class IDeterministicDeployerDeployCreate3AndInitContractFunction0(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate3AndInit(bytes,bytes,bytes,ICreateX.Values) method."""

    _function_name = "deployCreate3AndInit"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "bytes", "bytes", "ICreateX.Values"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate3AndInitContractFunction1(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate3AndInit(bytes,bytes,ICreateX.Values) method."""

    _function_name = "deployCreate3AndInit"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "bytes", "ICreateX.Values"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate3AndInitContractFunction2(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate3AndInit(bytes,bytes,bytes,ICreateX.Values,str) method."""

    _function_name = "deployCreate3AndInit"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "bytes", "bytes", "ICreateX.Values", "str"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate3AndInitContractFunction3(
    PypechainContractFunction
):
    """ContractFunction for the deployCreate3AndInit(bytes,bytes,ICreateX.Values,str) method."""

    _function_name = "deployCreate3AndInit"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "bytes", "ICreateX.Values", "str"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreate3AndInitContractFunction(
    PypechainOverloadedFunctions
):
    """ContractFunction for the deployCreate3AndInit method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    _function_name = "deployCreate3AndInit"

    # Make lookup for function signature -> overloaded function
    # The function signatures are python types, as we need to do a
    # lookup of arguments passed in to contract function
    _functions: dict[str, PypechainContractFunction]

    @overload
    def __call__(self, salt: bytes, initCode: bytes, data: bytes, values: ICreateX.Values) -> IDeterministicDeployerDeployCreate3AndInitContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, initCode: bytes, data: bytes, values: ICreateX.Values) -> IDeterministicDeployerDeployCreate3AndInitContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, salt: bytes, initCode: bytes, data: bytes, values: ICreateX.Values, refundAddress: str) -> IDeterministicDeployerDeployCreate3AndInitContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, initCode: bytes, data: bytes, values: ICreateX.Values, refundAddress: str) -> IDeterministicDeployerDeployCreate3AndInitContractFunction3:  # type: ignore
        ...

    def __call__(self, *args, **kwargs) -> IDeterministicDeployerDeployCreate3AndInitContractFunction:  # type: ignore
        # Special case when there are no args or kwargs
        if len(args) == 0 and len(kwargs) == 0:
            # We need to specify the element identifier as the function call without arguments.
            # Despite this setting the member variable `abi_element_identifier`
            # that's shared across this object, this field gets overwritten in the
            # clone if arguments are provided.
            self.abi_element_identifier = self._function_name + "()"
            clone = super().__call__()
        else:
            clone = super().__call__(
                *(dataclass_to_tuple(arg) for arg in args),
                **{key: dataclass_to_tuple(arg) for key, arg in kwargs.items()},
            )

        # Arguments is the flattened set of arguments from args and kwargs, ordered by the abi
        # We get the python types of the args passed in, but remapped from tuples -> dataclasses
        arg_types = get_arg_type_names(clone.arguments)

        # Grab the relevant kwargs when factory was called.
        factory_kwargs = self._factory_kwargs
        factory_kwargs["abi_element_identifier"] = clone.abi_element_identifier

        function_obj = self._overloaded_functions[arg_types].factory(
            self._function_name, **factory_kwargs
        )

        function_obj.args = clone.args
        function_obj.kwargs = clone.kwargs

        # The `@overload` of `__call__` takes care of setting the type of this object correctly
        return function_obj  # type: ignore

    @classmethod
    def factory(cls, class_name: str, **kwargs: Any) -> Self:
        out = super().factory(class_name, **kwargs)
        # Store the factory args for downstream consumption
        out._factory_kwargs = kwargs

        # We initialize our overridden functions here.
        # Note that we use the initialized object to ensure each function
        # is attached to the instantiated object
        # (attached to a specific web3 and contract address)
        out._overloaded_functions = {
            IDeterministicDeployerDeployCreate3AndInitContractFunction0._type_signature: IDeterministicDeployerDeployCreate3AndInitContractFunction0,
            IDeterministicDeployerDeployCreate3AndInitContractFunction1._type_signature: IDeterministicDeployerDeployCreate3AndInitContractFunction1,
            IDeterministicDeployerDeployCreate3AndInitContractFunction2._type_signature: IDeterministicDeployerDeployCreate3AndInitContractFunction2,
            IDeterministicDeployerDeployCreate3AndInitContractFunction3._type_signature: IDeterministicDeployerDeployCreate3AndInitContractFunction3,
        }
        return out


class IDeterministicDeployerDeployCreateAndInitContractFunction0(
    PypechainContractFunction
):
    """ContractFunction for the deployCreateAndInit(bytes,bytes,ICreateX.Values) method."""

    _function_name = "deployCreateAndInit"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "bytes", "ICreateX.Values"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreateAndInitContractFunction1(
    PypechainContractFunction
):
    """ContractFunction for the deployCreateAndInit(bytes,bytes,ICreateX.Values,str) method."""

    _function_name = "deployCreateAndInit"
    _type_signature = expand_struct_type_str(
        tuple(["bytes", "bytes", "ICreateX.Values", "str"]), structs
    )
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreateAndInitContractFunction(
    PypechainOverloadedFunctions
):
    """ContractFunction for the deployCreateAndInit method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    _function_name = "deployCreateAndInit"

    # Make lookup for function signature -> overloaded function
    # The function signatures are python types, as we need to do a
    # lookup of arguments passed in to contract function
    _functions: dict[str, PypechainContractFunction]

    @overload
    def __call__(self, initCode: bytes, data: bytes, values: ICreateX.Values) -> IDeterministicDeployerDeployCreateAndInitContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, initCode: bytes, data: bytes, values: ICreateX.Values, refundAddress: str) -> IDeterministicDeployerDeployCreateAndInitContractFunction1:  # type: ignore
        ...

    def __call__(self, *args, **kwargs) -> IDeterministicDeployerDeployCreateAndInitContractFunction:  # type: ignore
        # Special case when there are no args or kwargs
        if len(args) == 0 and len(kwargs) == 0:
            # We need to specify the element identifier as the function call without arguments.
            # Despite this setting the member variable `abi_element_identifier`
            # that's shared across this object, this field gets overwritten in the
            # clone if arguments are provided.
            self.abi_element_identifier = self._function_name + "()"
            clone = super().__call__()
        else:
            clone = super().__call__(
                *(dataclass_to_tuple(arg) for arg in args),
                **{key: dataclass_to_tuple(arg) for key, arg in kwargs.items()},
            )

        # Arguments is the flattened set of arguments from args and kwargs, ordered by the abi
        # We get the python types of the args passed in, but remapped from tuples -> dataclasses
        arg_types = get_arg_type_names(clone.arguments)

        # Grab the relevant kwargs when factory was called.
        factory_kwargs = self._factory_kwargs
        factory_kwargs["abi_element_identifier"] = clone.abi_element_identifier

        function_obj = self._overloaded_functions[arg_types].factory(
            self._function_name, **factory_kwargs
        )

        function_obj.args = clone.args
        function_obj.kwargs = clone.kwargs

        # The `@overload` of `__call__` takes care of setting the type of this object correctly
        return function_obj  # type: ignore

    @classmethod
    def factory(cls, class_name: str, **kwargs: Any) -> Self:
        out = super().factory(class_name, **kwargs)
        # Store the factory args for downstream consumption
        out._factory_kwargs = kwargs

        # We initialize our overridden functions here.
        # Note that we use the initialized object to ensure each function
        # is attached to the instantiated object
        # (attached to a specific web3 and contract address)
        out._overloaded_functions = {
            IDeterministicDeployerDeployCreateAndInitContractFunction0._type_signature: IDeterministicDeployerDeployCreateAndInitContractFunction0,
            IDeterministicDeployerDeployCreateAndInitContractFunction1._type_signature: IDeterministicDeployerDeployCreateAndInitContractFunction1,
        }
        return out


class IDeterministicDeployerDeployCreateCloneContractFunction0(
    PypechainContractFunction
):
    """ContractFunction for the deployCreateClone(str,bytes) method."""

    _function_name = "deployCreateClone"
    _type_signature = expand_struct_type_str(tuple(["str", "bytes"]), structs)
    _error_class = IDeterministicDeployerContractErrors

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier | None = None,
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # We handle the block identifier = None case here for typing.
        if block_identifier is None:
            block_identifier = self.w3.eth.default_block

        # Define the expected return types from the smart contract call
        return_types = str

        # Call the function
        raw_values = self._call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class IDeterministicDeployerDeployCreateCloneContractFunction(
    PypechainOverloadedFunctions
):
    """ContractFunction for the deployCreateClone method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    _function_name = "deployCreateClone"

    # Make lookup for function signature -> overloaded function
    # The function signatures are python types, as we need to do a
    # lookup of arguments passed in to contract function
    _functions: dict[str, PypechainContractFunction]

    @overload
    def __call__(self, implementation: str, data: bytes) -> IDeterministicDeployerDeployCreateCloneContractFunction0:  # type: ignore
        ...

    def __call__(self, *args, **kwargs) -> IDeterministicDeployerDeployCreateCloneContractFunction:  # type: ignore
        # Special case when there are no args or kwargs
        if len(args) == 0 and len(kwargs) == 0:
            # We need to specify the element identifier as the function call without arguments.
            # Despite this setting the member variable `abi_element_identifier`
            # that's shared across this object, this field gets overwritten in the
            # clone if arguments are provided.
            self.abi_element_identifier = self._function_name + "()"
            clone = super().__call__()
        else:
            clone = super().__call__(
                *(dataclass_to_tuple(arg) for arg in args),
                **{key: dataclass_to_tuple(arg) for key, arg in kwargs.items()},
            )

        # Arguments is the flattened set of arguments from args and kwargs, ordered by the abi
        # We get the python types of the args passed in, but remapped from tuples -> dataclasses
        arg_types = get_arg_type_names(clone.arguments)

        # Grab the relevant kwargs when factory was called.
        factory_kwargs = self._factory_kwargs
        factory_kwargs["abi_element_identifier"] = clone.abi_element_identifier

        function_obj = self._overloaded_functions[arg_types].factory(
            self._function_name, **factory_kwargs
        )

        function_obj.args = clone.args
        function_obj.kwargs = clone.kwargs

        # The `@overload` of `__call__` takes care of setting the type of this object correctly
        return function_obj  # type: ignore

    @classmethod
    def factory(cls, class_name: str, **kwargs: Any) -> Self:
        out = super().factory(class_name, **kwargs)
        # Store the factory args for downstream consumption
        out._factory_kwargs = kwargs

        # We initialize our overridden functions here.
        # Note that we use the initialized object to ensure each function
        # is attached to the instantiated object
        # (attached to a specific web3 and contract address)
        out._overloaded_functions = {
            IDeterministicDeployerDeployCreateCloneContractFunction0._type_signature: IDeterministicDeployerDeployCreateCloneContractFunction0,
        }
        return out


class IDeterministicDeployerContractFunctions(ContractFunctions):
    """ContractFunctions for the IDeterministicDeployer contract."""

    computeCreate2Address: (
        IDeterministicDeployerComputeCreate2AddressContractFunction
    )

    computeCreate3Address: (
        IDeterministicDeployerComputeCreate3AddressContractFunction
    )

    computeCreateAddress: (
        IDeterministicDeployerComputeCreateAddressContractFunction
    )

    deployCreate: IDeterministicDeployerDeployCreateContractFunction

    deployCreate2: IDeterministicDeployerDeployCreate2ContractFunction

    deployCreate2AndInit: (
        IDeterministicDeployerDeployCreate2AndInitContractFunction
    )

    deployCreate2Clone: IDeterministicDeployerDeployCreate2CloneContractFunction

    deployCreate3: IDeterministicDeployerDeployCreate3ContractFunction

    deployCreate3AndInit: (
        IDeterministicDeployerDeployCreate3AndInitContractFunction
    )

    deployCreateAndInit: (
        IDeterministicDeployerDeployCreateAndInitContractFunction
    )

    deployCreateClone: IDeterministicDeployerDeployCreateCloneContractFunction

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
        decode_tuples: bool | None = False,
    ) -> None:
        super().__init__(abi, w3, address, decode_tuples)
        self.computeCreate2Address = (
            IDeterministicDeployerComputeCreate2AddressContractFunction.factory(
                "computeCreate2Address",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="computeCreate2Address",
            )
        )
        self.computeCreate3Address = (
            IDeterministicDeployerComputeCreate3AddressContractFunction.factory(
                "computeCreate3Address",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="computeCreate3Address",
            )
        )
        self.computeCreateAddress = (
            IDeterministicDeployerComputeCreateAddressContractFunction.factory(
                "computeCreateAddress",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="computeCreateAddress",
            )
        )
        self.deployCreate = (
            IDeterministicDeployerDeployCreateContractFunction.factory(
                "deployCreate",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="deployCreate",
            )
        )
        self.deployCreate2 = (
            IDeterministicDeployerDeployCreate2ContractFunction.factory(
                "deployCreate2",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="deployCreate2",
            )
        )
        self.deployCreate2AndInit = (
            IDeterministicDeployerDeployCreate2AndInitContractFunction.factory(
                "deployCreate2AndInit",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="deployCreate2AndInit",
            )
        )
        self.deployCreate2Clone = (
            IDeterministicDeployerDeployCreate2CloneContractFunction.factory(
                "deployCreate2Clone",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="deployCreate2Clone",
            )
        )
        self.deployCreate3 = (
            IDeterministicDeployerDeployCreate3ContractFunction.factory(
                "deployCreate3",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="deployCreate3",
            )
        )
        self.deployCreate3AndInit = (
            IDeterministicDeployerDeployCreate3AndInitContractFunction.factory(
                "deployCreate3AndInit",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="deployCreate3AndInit",
            )
        )
        self.deployCreateAndInit = (
            IDeterministicDeployerDeployCreateAndInitContractFunction.factory(
                "deployCreateAndInit",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="deployCreateAndInit",
            )
        )
        self.deployCreateClone = (
            IDeterministicDeployerDeployCreateCloneContractFunction.factory(
                "deployCreateClone",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="deployCreateClone",
            )
        )


class IDeterministicDeployerContractCreationContractEvent(ContractEvent):
    """ContractEvent for ContractCreation."""

    # super() get_logs and create_filter methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ

    # pylint: disable=useless-parent-delegation
    def __init__(self, *argument_names: tuple[str]) -> None:
        super().__init__(*argument_names)

    @combomethod_typed
    def get_logs_typed(
        self,
        argument_filters: dict[str, Any] | None = None,
        from_block: BlockIdentifier | None = None,
        to_block: BlockIdentifier | None = None,
        block_hash: HexBytes | None = None,
    ) -> Iterable[ContractCreationEvent]:
        """Extension of `get_logs` that return a typed dataclass of the event."""
        abi_events = super().get_logs(
            argument_filters=argument_filters,
            from_block=from_block,
            to_block=to_block,
            block_hash=block_hash,
        )
        # TODO there may be issues with this function if the user uses a middleware that changes event structure.
        return [
            ContractCreationEvent(
                log_index=abi_event.logIndex,
                transaction_index=abi_event.transactionIndex,
                transaction_hash=abi_event.transactionHash,
                address=abi_event.address,
                block_hash=abi_event.blockHash,
                block_number=abi_event.blockNumber,
                args=ContractCreationEvent.ContractCreationEventArgs(
                    newContract=abi_event.args["newContract"],
                ),
            )
            for abi_event in abi_events
        ]

    @combomethod_typed
    def process_receipt_typed(
        self, txn_receipt: TxReceipt, errors: EventLogErrorFlags = WARN
    ) -> Iterable[ContractCreationEvent]:
        """Extension of `process_receipt` that return a typed dataclass of the event."""
        abi_events = super().process_receipt(txn_receipt, errors)
        # TODO there may be issues with this function if the user uses a middleware that changes event structure.
        return [
            ContractCreationEvent(
                log_index=abi_event.logIndex,
                transaction_index=abi_event.transactionIndex,
                transaction_hash=abi_event.transactionHash,
                address=abi_event.address,
                block_hash=abi_event.blockHash,
                block_number=abi_event.blockNumber,
                args=ContractCreationEvent.ContractCreationEventArgs(
                    newContract=abi_event.args["newContract"],
                ),
            )
            for abi_event in abi_events
        ]

    @combomethod_typed
    def create_filter(  # type: ignore
        self,
        *,  # PEP 3102
        argument_filters: dict[str, Any] | None = None,
        from_block: BlockIdentifier | None = None,
        to_block: BlockIdentifier = "latest",
        address: ChecksumAddress | None = None,
        topics: Sequence[Any] | None = None,
    ) -> LogFilter:
        return cast(
            LogFilter,
            super().create_filter(
                argument_filters=argument_filters,
                from_block=from_block,
                to_block=to_block,
                address=address,
                topics=topics,
            ),
        )


class IDeterministicDeployerCreate3ProxyContractCreationContractEvent(
    ContractEvent
):
    """ContractEvent for Create3ProxyContractCreation."""

    # super() get_logs and create_filter methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ

    # pylint: disable=useless-parent-delegation
    def __init__(self, *argument_names: tuple[str]) -> None:
        super().__init__(*argument_names)

    @combomethod_typed
    def get_logs_typed(
        self,
        argument_filters: dict[str, Any] | None = None,
        from_block: BlockIdentifier | None = None,
        to_block: BlockIdentifier | None = None,
        block_hash: HexBytes | None = None,
    ) -> Iterable[Create3ProxyContractCreationEvent]:
        """Extension of `get_logs` that return a typed dataclass of the event."""
        abi_events = super().get_logs(
            argument_filters=argument_filters,
            from_block=from_block,
            to_block=to_block,
            block_hash=block_hash,
        )
        # TODO there may be issues with this function if the user uses a middleware that changes event structure.
        return [
            Create3ProxyContractCreationEvent(
                log_index=abi_event.logIndex,
                transaction_index=abi_event.transactionIndex,
                transaction_hash=abi_event.transactionHash,
                address=abi_event.address,
                block_hash=abi_event.blockHash,
                block_number=abi_event.blockNumber,
                args=Create3ProxyContractCreationEvent.Create3ProxyContractCreationEventArgs(
                    newContract=abi_event.args["newContract"],
                    salt=abi_event.args["salt"],
                ),
            )
            for abi_event in abi_events
        ]

    @combomethod_typed
    def process_receipt_typed(
        self, txn_receipt: TxReceipt, errors: EventLogErrorFlags = WARN
    ) -> Iterable[Create3ProxyContractCreationEvent]:
        """Extension of `process_receipt` that return a typed dataclass of the event."""
        abi_events = super().process_receipt(txn_receipt, errors)
        # TODO there may be issues with this function if the user uses a middleware that changes event structure.
        return [
            Create3ProxyContractCreationEvent(
                log_index=abi_event.logIndex,
                transaction_index=abi_event.transactionIndex,
                transaction_hash=abi_event.transactionHash,
                address=abi_event.address,
                block_hash=abi_event.blockHash,
                block_number=abi_event.blockNumber,
                args=Create3ProxyContractCreationEvent.Create3ProxyContractCreationEventArgs(
                    newContract=abi_event.args["newContract"],
                    salt=abi_event.args["salt"],
                ),
            )
            for abi_event in abi_events
        ]

    @combomethod_typed
    def create_filter(  # type: ignore
        self,
        *,  # PEP 3102
        argument_filters: dict[str, Any] | None = None,
        from_block: BlockIdentifier | None = None,
        to_block: BlockIdentifier = "latest",
        address: ChecksumAddress | None = None,
        topics: Sequence[Any] | None = None,
    ) -> LogFilter:
        return cast(
            LogFilter,
            super().create_filter(
                argument_filters=argument_filters,
                from_block=from_block,
                to_block=to_block,
                address=address,
                topics=topics,
            ),
        )


class IDeterministicDeployerContractEvents(ContractEvents):
    """ContractEvents for the IDeterministicDeployer contract."""

    ContractCreation: IDeterministicDeployerContractCreationContractEvent

    Create3ProxyContractCreation: (
        IDeterministicDeployerCreate3ProxyContractCreationContractEvent
    )

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
    ) -> None:
        super().__init__(abi, w3, address)
        self.ContractCreation = (
            IDeterministicDeployerContractCreationContractEvent.factory(
                "ContractCreation",
                w3=w3,
                contract_abi=abi,
                address=address,
                event_name="ContractCreation",
            )
        )
        self.Create3ProxyContractCreation = IDeterministicDeployerCreate3ProxyContractCreationContractEvent.factory(
            "Create3ProxyContractCreation",
            w3=w3,
            contract_abi=abi,
            address=address,
            event_name="Create3ProxyContractCreation",
        )


class IDeterministicDeployerContract(Contract):
    """A web3.py Contract class for the IDeterministicDeployer contract."""

    abi: ABI = ideterministicdeployer_abi
    # We change `bytecode` as needed for linking, but keep
    # `_raw_bytecode` unchanged as an original copy.
    # pylint: disable=line-too-long
    _raw_bytecode: HexStr | None = HexStr("0x")

    def __init__(self, address: ChecksumAddress | None = None) -> None:
        # Initialize parent Contract class
        super().__init__(address=address)
        self.functions = IDeterministicDeployerContractFunctions(ideterministicdeployer_abi, self.w3, address)  # type: ignore
        self.events = IDeterministicDeployerContractEvents(ideterministicdeployer_abi, self.w3, address)  # type: ignore
        self.errors = IDeterministicDeployerContractErrors()

    events: IDeterministicDeployerContractEvents

    errors: IDeterministicDeployerContractErrors = (
        IDeterministicDeployerContractErrors()
    )

    functions: IDeterministicDeployerContractFunctions

    @classmethod
    def constructor(cls) -> ContractConstructor:  # type: ignore
        """Creates a transaction with the contract's constructor function.

        Parameters
        ----------

        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.

        """
        cls.bytecode = cls._raw_bytecode
        if cls.bytecode is not None:

            # bytecode needs to be in hex for web3
            cls.bytecode = HexBytes(cls.bytecode)

        return super().constructor()

    @classmethod
    def deploy(cls, w3: Web3, account: LocalAccount | ChecksumAddress) -> Self:
        """Deploys an instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        deployer = cls.factory(w3=w3)
        constructor_fn = deployer.constructor()

        # if an address is supplied, try to use a web3 default account
        if isinstance(account, str):
            tx_hash = constructor_fn.transact({"from": account})
            tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

            deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
            return deployed_contract

        # otherwise use the account provided.
        deployment_tx = constructor_fn.build_transaction()
        current_nonce = w3.eth.get_transaction_count(account.address, "pending")
        deployment_tx.update({"nonce": current_nonce})

        # Sign the transaction with local account private key
        signed_tx = account.sign_transaction(deployment_tx)

        # Send the signed transaction and wait for receipt
        tx_hash = w3.eth.send_raw_transaction(signed_tx.raw_transaction)
        tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

        deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
        return deployed_contract

    @classmethod
    def factory(
        cls, w3: Web3, class_name: str | None = None, **kwargs: Any
    ) -> Type[Self]:
        """Initializes the contract object.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        class_name: str | None
            The instance class name.

        Returns
        -------
        Self
            An instance of the contract class.
        """
        contract = super().factory(w3, class_name, **kwargs)
        contract.functions = IDeterministicDeployerContractFunctions(
            ideterministicdeployer_abi, w3, None
        )
        contract.errors = IDeterministicDeployerContractErrors()

        return contract
