"""A web3.py Contract class for the IERC20Errors contract.

DO NOT EDIT.  This file was generated by pypechain v0.0.49.
See documentation at https://github.com/delvtech/pypechain """

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# This file is bound to get very long depending on contract sizes.
# pylint: disable=too-many-lines

# methods are overridden with specific arguments instead of generic *args, **kwargs
# pylint: disable=arguments-differ

# consumers have too many opinions on line length
# pylint: disable=line-too-long

# We use protected classes within pypechain
# pylint: disable=protected-access

# We sometimes define a variable that might not be returned in `call`,
# but we still may want to call the function
# pylint: disable=unused-variable


from __future__ import annotations

from typing import Any, Type, cast

from eth_account.signers.local import LocalAccount
from eth_typing import ABI, ChecksumAddress, HexStr
from hexbytes import HexBytes
from pypechain.core import PypechainBaseContractErrors, PypechainBaseError
from typing_extensions import Self
from web3 import Web3
from web3.contract.contract import (
    Contract,
    ContractConstructor,
    ContractFunctions,
)

structs = {}

ierc20errors_abi: ABI = cast(
    ABI,
    [
        {
            "type": "error",
            "name": "ERC20InsufficientAllowance",
            "inputs": [
                {
                    "name": "spender",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "allowance",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "needed",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
        },
        {
            "type": "error",
            "name": "ERC20InsufficientBalance",
            "inputs": [
                {
                    "name": "sender",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "balance",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "needed",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
        },
        {
            "type": "error",
            "name": "ERC20InvalidApprover",
            "inputs": [
                {
                    "name": "approver",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC20InvalidReceiver",
            "inputs": [
                {
                    "name": "receiver",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC20InvalidSender",
            "inputs": [
                {"name": "sender", "type": "address", "internalType": "address"}
            ],
        },
        {
            "type": "error",
            "name": "ERC20InvalidSpender",
            "inputs": [
                {
                    "name": "spender",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
    ],
)


class IERC20ErrorsERC20InsufficientAllowanceContractError(PypechainBaseError):
    """ContractError for ERC20InsufficientAllowance."""

    # Error name
    name: str = "ERC20InsufficientAllowance"
    # 4 byte error selector
    selector: str = "0xfb8f41b2"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC20InsufficientAllowance(address,uint256,uint256)"
    # Error input types
    abi: ABI = ierc20errors_abi


class IERC20ErrorsERC20InsufficientBalanceContractError(PypechainBaseError):
    """ContractError for ERC20InsufficientBalance."""

    # Error name
    name: str = "ERC20InsufficientBalance"
    # 4 byte error selector
    selector: str = "0xe450d38c"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC20InsufficientBalance(address,uint256,uint256)"
    # Error input types
    abi: ABI = ierc20errors_abi


class IERC20ErrorsERC20InvalidApproverContractError(PypechainBaseError):
    """ContractError for ERC20InvalidApprover."""

    # Error name
    name: str = "ERC20InvalidApprover"
    # 4 byte error selector
    selector: str = "0xe602df05"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC20InvalidApprover(address)"
    # Error input types
    abi: ABI = ierc20errors_abi


class IERC20ErrorsERC20InvalidReceiverContractError(PypechainBaseError):
    """ContractError for ERC20InvalidReceiver."""

    # Error name
    name: str = "ERC20InvalidReceiver"
    # 4 byte error selector
    selector: str = "0xec442f05"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC20InvalidReceiver(address)"
    # Error input types
    abi: ABI = ierc20errors_abi


class IERC20ErrorsERC20InvalidSenderContractError(PypechainBaseError):
    """ContractError for ERC20InvalidSender."""

    # Error name
    name: str = "ERC20InvalidSender"
    # 4 byte error selector
    selector: str = "0x96c6fd1e"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC20InvalidSender(address)"
    # Error input types
    abi: ABI = ierc20errors_abi


class IERC20ErrorsERC20InvalidSpenderContractError(PypechainBaseError):
    """ContractError for ERC20InvalidSpender."""

    # Error name
    name: str = "ERC20InvalidSpender"
    # 4 byte error selector
    selector: str = "0x94280d62"
    # error signature, i.e. CustomError(uint256,bool)
    signature: str = "ERC20InvalidSpender(address)"
    # Error input types
    abi: ABI = ierc20errors_abi


class IERC20ErrorsContractErrors(PypechainBaseContractErrors):
    """ContractErrors for the IERC20Errors contract."""

    ERC20InsufficientAllowance: (
        IERC20ErrorsERC20InsufficientAllowanceContractError
    )

    ERC20InsufficientBalance: IERC20ErrorsERC20InsufficientBalanceContractError

    ERC20InvalidApprover: IERC20ErrorsERC20InvalidApproverContractError

    ERC20InvalidReceiver: IERC20ErrorsERC20InvalidReceiverContractError

    ERC20InvalidSender: IERC20ErrorsERC20InvalidSenderContractError

    ERC20InvalidSpender: IERC20ErrorsERC20InvalidSpenderContractError

    def __init__(
        self,
    ) -> None:
        self.ERC20InsufficientAllowance = (
            IERC20ErrorsERC20InsufficientAllowanceContractError()
        )
        self.ERC20InsufficientBalance = (
            IERC20ErrorsERC20InsufficientBalanceContractError()
        )
        self.ERC20InvalidApprover = (
            IERC20ErrorsERC20InvalidApproverContractError()
        )
        self.ERC20InvalidReceiver = (
            IERC20ErrorsERC20InvalidReceiverContractError()
        )
        self.ERC20InvalidSender = IERC20ErrorsERC20InvalidSenderContractError()
        self.ERC20InvalidSpender = (
            IERC20ErrorsERC20InvalidSpenderContractError()
        )

        self._all = [
            self.ERC20InsufficientAllowance,
            self.ERC20InsufficientBalance,
            self.ERC20InvalidApprover,
            self.ERC20InvalidReceiver,
            self.ERC20InvalidSender,
            self.ERC20InvalidSpender,
        ]


class IERC20ErrorsContractFunctions(ContractFunctions):
    """ContractFunctions for the IERC20Errors contract."""

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
        decode_tuples: bool | None = False,
    ) -> None:
        super().__init__(abi, w3, address, decode_tuples)


class IERC20ErrorsContract(Contract):
    """A web3.py Contract class for the IERC20Errors contract."""

    abi: ABI = ierc20errors_abi
    # We change `bytecode` as needed for linking, but keep
    # `_raw_bytecode` unchanged as an original copy.
    # pylint: disable=line-too-long
    _raw_bytecode: HexStr | None = HexStr("0x")

    def __init__(self, address: ChecksumAddress | None = None) -> None:
        # Initialize parent Contract class
        super().__init__(address=address)
        self.functions = IERC20ErrorsContractFunctions(ierc20errors_abi, self.w3, address)  # type: ignore

        self.errors = IERC20ErrorsContractErrors()

    errors: IERC20ErrorsContractErrors = IERC20ErrorsContractErrors()

    functions: IERC20ErrorsContractFunctions

    @classmethod
    def constructor(cls) -> ContractConstructor:  # type: ignore
        """Creates a transaction with the contract's constructor function.

        Parameters
        ----------

        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.

        """
        cls.bytecode = cls._raw_bytecode
        if cls.bytecode is not None:

            # bytecode needs to be in hex for web3
            cls.bytecode = HexBytes(cls.bytecode)

        return super().constructor()

    @classmethod
    def deploy(cls, w3: Web3, account: LocalAccount | ChecksumAddress) -> Self:
        """Deploys an instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        deployer = cls.factory(w3=w3)
        constructor_fn = deployer.constructor()

        # if an address is supplied, try to use a web3 default account
        if isinstance(account, str):
            tx_hash = constructor_fn.transact({"from": account})
            tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

            deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
            return deployed_contract

        # otherwise use the account provided.
        deployment_tx = constructor_fn.build_transaction()
        current_nonce = w3.eth.get_transaction_count(account.address, "pending")
        deployment_tx.update({"nonce": current_nonce})

        # Sign the transaction with local account private key
        signed_tx = account.sign_transaction(deployment_tx)

        # Send the signed transaction and wait for receipt
        tx_hash = w3.eth.send_raw_transaction(signed_tx.raw_transaction)
        tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

        deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
        return deployed_contract

    @classmethod
    def factory(
        cls, w3: Web3, class_name: str | None = None, **kwargs: Any
    ) -> Type[Self]:
        """Initializes the contract object.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        class_name: str | None
            The instance class name.

        Returns
        -------
        Self
            An instance of the contract class.
        """
        contract = super().factory(w3, class_name, **kwargs)
        contract.functions = IERC20ErrorsContractFunctions(
            ierc20errors_abi, w3, None
        )
        contract.errors = IERC20ErrorsContractErrors()

        return contract
