"""Dataclasses for all structs in the IHyperdriveMatchingEngine contract.

DO NOT EDIT.  This file was generated by pypechain v0.0.49.
See documentation at https://github.com/delvtech/pypechain """

# super() call methods are generic, while our version adds values & types
# pylint: disable=arguments-differ

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# unable to determine which imports will be used in the generated code
# pylint: disable=unused-import

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# We import this contract itself to ensure all nested structs have a fully qualified name.
# We use this to avoid namespace collisions, as well as having a uniform
# type structure to do lookups when functions return these structs.
# pylint: disable=import-self


from __future__ import annotations

from dataclasses import dataclass

from pypechain.core import BaseEvent, BaseEventArgs, ErrorInfo

from ..IHyperdrive import IHyperdriveTypes as IHyperdrive


@dataclass(kw_only=True)
class OrdersCancelledEvent(BaseEvent):
    """The event type for event OrdersCancelled"""

    @dataclass(kw_only=True)
    class OrdersCancelledEventArgs(BaseEventArgs):
        """The args to the event OrdersCancelled"""

        trader: str
        orderHashes: list[bytes]

    # We redefine the args field with the specific event arg type.
    args: OrdersCancelledEventArgs  # type: ignore[override]

    __name__: str = "OrdersCancelled"


@dataclass(kw_only=True)
class OrdersMatchedEvent(BaseEvent):
    """The event type for event OrdersMatched"""

    @dataclass(kw_only=True)
    class OrdersMatchedEventArgs(BaseEventArgs):
        """The args to the event OrdersMatched"""

        hyperdrive: str
        longOrderHash: bytes
        shortOrderHash: bytes
        long: str
        short: str

    # We redefine the args field with the specific event arg type.
    args: OrdersMatchedEventArgs  # type: ignore[override]

    __name__: str = "OrdersMatched"


@dataclass
class OrderIntent:
    """OrderIntent struct."""

    trader: str
    hyperdrive: str
    amount: int
    slippageGuard: int
    minVaultSharePrice: int
    options: IHyperdrive.Options
    orderType: int
    signature: bytes
    expiry: int
    salt: bytes


AlreadyCancelledError = ErrorInfo(
    inputs=[],
    name="AlreadyCancelled",
    selector="0x54e37625",
    signature="AlreadyCancelled()",
)

AlreadyExpiredError = ErrorInfo(
    inputs=[],
    name="AlreadyExpired",
    selector="0xa0d64f8a",
    signature="AlreadyExpired()",
)

InvalidDestinationError = ErrorInfo(
    inputs=[],
    name="InvalidDestination",
    selector="0xac6b05f5",
    signature="InvalidDestination()",
)

InvalidMatchError = ErrorInfo(
    inputs=[],
    name="InvalidMatch",
    selector="0x29ac473e",
    signature="InvalidMatch()",
)

InvalidOrderTypeError = ErrorInfo(
    inputs=[],
    name="InvalidOrderType",
    selector="0x688c176f",
    signature="InvalidOrderType()",
)

InvalidSenderError = ErrorInfo(
    inputs=[],
    name="InvalidSender",
    selector="0xddb5de5e",
    signature="InvalidSender()",
)

InvalidSettlementAssetError = ErrorInfo(
    inputs=[],
    name="InvalidSettlementAsset",
    selector="0xabca264a",
    signature="InvalidSettlementAsset()",
)

InvalidSignatureError = ErrorInfo(
    inputs=[],
    name="InvalidSignature",
    selector="0x8baa579f",
    signature="InvalidSignature()",
)

MismatchedHyperdriveError = ErrorInfo(
    inputs=[],
    name="MismatchedHyperdrive",
    selector="0x4cf1ffa4",
    signature="MismatchedHyperdrive()",
)
